## visp 3.1.0

=== CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. Detect third party libraries (X11, GTK, ...)
#
# Authors:
# Fabien Spindler
#
#############################################################################

# Detect crosscompiling; need to be before project(VISP) to work
if(NOT CMAKE_TOOLCHAIN_FILE)
  # Modify default install prefix
  if(WIN32)
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory")
  endif()
else()
  # Crosscompiling
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory")
endif()

if(CMAKE_SYSTEM_NAME MATCHES WindowsPhone OR CMAKE_SYSTEM_NAME MATCHES WindowsStore)
  set(WINRT TRUE)
endif(CMAKE_SYSTEM_NAME MATCHES WindowsPhone OR CMAKE_SYSTEM_NAME MATCHES WindowsStore)

if(WINRT)
  add_definitions(-DWINRT)

  if(CMAKE_SYSTEM_NAME MATCHES WindowsPhone)
    set(WINRT_PHONE TRUE)
    add_definitions(-DWINRT_PHONE)
  elseif(CMAKE_SYSTEM_NAME MATCHES WindowsStore)
    set(WINRT_STORE TRUE)
    add_definitions(-DWINRT_STORE)
  endif()

  if(CMAKE_SYSTEM_VERSION MATCHES 10 OR CMAKE_SYSTEM_VERSION MATCHES 10.0)
    set(WINRT_10 TRUE)
    add_definitions(-DWINRT_10)
  elseif(CMAKE_SYSTEM_VERSION MATCHES 8.1)
    set(WINRT_8_1 TRUE)
    add_definitions(-DWINRT_8_1)
  elseif(CMAKE_SYSTEM_VERSION MATCHES 8.0)
    set(WINRT_8_0 TRUE)
    add_definitions(-DWINRT_8_0)
  endif()
endif()

# By default set release configuration
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE String "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

project(VISP C CXX)

# Detect if the toolchain is for Aldebaran naoqi
if(CMAKE_TOOLCHAIN_FILE AND I_AM_A_ROBOT)
  include(platforms/naoqi/cmake/extra.cmake)
endif()

cmake_minimum_required(VERSION 2.8.12.2)

if(POLICY CMP0022)
  cmake_policy(SET CMP0022 NEW) # Due to sensor ATIDAQ_LIBRARIES
endif()
if(POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW) # For UsTK: VTK and Qt5
endif()
if(POLICY CMP0020)
  cmake_policy(SET CMP0020 NEW) # For UsTK: Qt5
endif()
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW) # To turn off a warning in native FindOpenMP with cmake 3.9.2
endif()

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(cmake/VISPUtils.cmake)

vp_clear_vars(VISPModules_TARGETS)

#-----------------------------------------------------------------------------
# VISP version number.  An even minor number corresponds to releases.
set(VISP_VERSION_MAJOR "3")
set(VISP_VERSION_MINOR "1")
set(VISP_VERSION_PATCH "0")
set(VISP_VERSION "${VISP_VERSION_MAJOR}.${VISP_VERSION_MINOR}.${VISP_VERSION_PATCH}")
# Package revision number
set(VISP_REVISION "1")

find_file(GNU_INSTALL_DIRS_FROM_CMAKE NAMES GNUInstallDirs.cmake PATHS ${CMAKE_ROOT}/Modules)
mark_as_advanced(GNU_INSTALL_DIRS_FROM_CMAKE)
if(GNU_INSTALL_DIRS_FROM_CMAKE)
  include(${CMAKE_ROOT}/Modules/GNUInstallDirs.cmake)
else()
  include(cmake/GNUInstallDirs.cmake)
endif()

#----------------------------------------------------------------------
# Platform specific
#----------------------------------------------------------------------
include(cmake/VISPDetectPlatform.cmake)

# Set the path where to install the lib
if(WIN32)
  if(DEFINED VISP_RUNTIME AND DEFINED VISP_ARCH)
    set(VISP_INSTALL_BINARIES_PREFIX "${VISP_ARCH}/${VISP_RUNTIME}/")
  else()
    message(STATUS "Can't detect runtime and/or arch")
    set(VISP_INSTALL_BINARIES_PREFIX "")
  endif()
else()
  set(VISP_INSTALL_BINARIES_PREFIX "")
endif()

# where to install the library and headers
if(WIN32)
  set(VISP_INC_INSTALL_PATH     ${CMAKE_INSTALL_INCLUDEDIR})
  if(VISP_STATIC)
    set(VISP_LIB_INSTALL_PATH  "${VISP_INSTALL_BINARIES_PREFIX}static${CMAKE_INSTALL_LIBDIR}")
  else()
    set(VISP_LIB_INSTALL_PATH  "${VISP_INSTALL_BINARIES_PREFIX}${CMAKE_INSTALL_LIBDIR}")
  endif()
  set(VISP_BIN_INSTALL_PATH    "${VISP_INSTALL_BINARIES_PREFIX}${CMAKE_INSTALL_BINDIR}")
  set(VISP_3P_LIB_INSTALL_PATH "${VISP_INSTALL_BINARIES_PREFIX}static${CMAKE_INSTALL_LIBDIR}")
else()
  # The location where includes and libraries will be installed

  # The 2 following commented lines should be used to enable multi-arch support.
  # Since catkin doesn't support multi-arch we keep these 2 lines commented for the moment.
  # set(VISP_INC_INSTALL_PATH     ${CMAKE_INSTALL_INCLUDEDIR}/${CMAKE_LIBRARY_ARCHITECTURE})
  # set(VISP_LIB_INSTALL_PATH     ${CMAKE_INSTALL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE})
  set(VISP_INC_INSTALL_PATH     ${CMAKE_INSTALL_INCLUDEDIR})
  set(VISP_LIB_INSTALL_PATH     ${CMAKE_INSTALL_LIBDIR})
  set(VISP_BIN_INSTALL_PATH     ${CMAKE_INSTALL_BINDIR})
  set(VISP_3P_LIB_INSTALL_PATH  share/ViSP/3rdparty/${VISP_LIB_INSTALL_PATH})
endif()
set(VISP_3P_LIBRARY_OUTPUT_PATH "${VISP_BINARY_DIR}/3rdparty/lib")

# the include directory we depend on for the build
set(VISP_INCLUDE_DIR ${VISP_BINARY_DIR}/${VISP_INC_INSTALL_PATH})
set(VISP_DOC_DIR "${VISP_BINARY_DIR}/doc")

# The location where includes and libraries will be build
set(LIBRARY_OUTPUT_PATH ${VISP_BINARY_DIR}/${VISP_LIB_INSTALL_PATH})
set(BINARY_OUTPUT_PATH ${VISP_BINARY_DIR}/${VISP_BIN_INSTALL_PATH})

if(WIN32)
  # Postfix of .lib and .dll
  set(VISP_DEBUG_POSTFIX "d")
  set(VISP_DLLVERSION "${VISP_VERSION_MAJOR}${VISP_VERSION_MINOR}${VISP_VERSION_PATCH}")
else()
  set(VISP_DEBUG_POSTFIX "")
  set(VISP_DLLVERSION "")
endif()

include_directories(${VISP_INCLUDE_DIR})

#----------------------------------------------------------------------
# SSE optimization
#----------------------------------------------------------------------
VP_OPTION(ENABLE_SSE2  "" "" "Enable SSE2 instructions"  "" ON IF ((MSVC OR CMAKE_COMPILER_IS_GNUCXX) AND (X86 OR X86_64)) )
VP_OPTION(ENABLE_SSE3  "" "" "Enable SSE3 instructions"  "" ON IF ((MSVC OR CMAKE_COMPILER_IS_GNUCXX) AND (X86 OR X86_64)) )
VP_OPTION(ENABLE_SSSE3 "" "" "Enable SSSE3 instructions" "" ON IF ((MSVC OR CMAKE_COMPILER_IS_GNUCXX) AND (X86_64)) ) # X86 disabled since it produces an issue on Debian i386

# ----------------------------------------------------------------------------
# Handle always full RPATH
# http://www.cmake.org/Wiki/CMake_RPATH_handling
# ----------------------------------------------------------------------------

# avoid CMP0042 warning
if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
endif()

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${VISP_LIB_INSTALL_PATH}")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${VISP_LIB_INSTALL_PATH}" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${VISP_LIB_INSTALL_PATH}")
endif("${isSystemDir}" STREQUAL "-1")

# ----------------------------------------------------------------------------
#  Path for additional contrib modules
# ----------------------------------------------------------------------------
set(VISP_CONTRIB_MODULES_PATH "" CACHE PATH "Where to look for additional contrib ViSP modules")

# Get the OS
set(OS ${CMAKE_SYSTEM_NAME})

set(OGRE_DIR $ENV{OGRE_DIR})
if(NOT OGRE_DIR) # For compat with previous ViSP versions
  set(OGRE_DIR $ENV{OGRE_HOME})
endif()
if(OGRE_DIR)
  # replace \ with / especially for windows
  STRING(REGEX REPLACE "\\\\" "/" OGRE_DIR ${OGRE_DIR})
endif()

# add the path to detect Ogre3D
if(WIN32)
  list(APPEND CMAKE_MODULE_PATH "${OGRE_DIR}/cmake")
  list(APPEND CMAKE_MODULE_PATH "${OGRE_DIR}/CMake")
endif(WIN32)

if(UNIX)
  list(APPEND CMAKE_MODULE_PATH "${OGRE_DIR}/cmake")
  list(APPEND CMAKE_MODULE_PATH "${OGRE_DIR}/CMake")
  list(APPEND CMAKE_MODULE_PATH "/usr/local/lib/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/lib/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/local/lib64/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/lib64/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/share/OGRE/cmake/modules")
endif(UNIX)

#--------------------------------------------------------------------
# Option management
#--------------------------------------------------------------------

# Choose static or shared libraries.
VP_OPTION(BUILD_SHARED_LIBS  "" "" "Build ViSP shared libraries (.dll/.so) instead of static ones (.lib/.a)" "" NOT APPLE_FRAMEWORK)
# Build examples as an option.
VP_OPTION(BUILD_EXAMPLES  "" "" "Build ViSP examples" "" ON)
# Build examples as an option.
VP_OPTION(BUILD_TESTS  "" "" "Build ViSP tests" "" ON)
VP_OPTION(BUILD_COVERAGE "" "" "Enables test coverage" "" OFF IF (BUILD_TESTS AND CMAKE_COMPILER_IS_GNUCXX AND CMAKE_BUILD_TYPE MATCHES "Debug"))

# Build demos as an option.
VP_OPTION(BUILD_DEMOS  "" "" "Build ViSP demos" "" ON)
# Build tutorials as an option.
VP_OPTION(BUILD_TUTORIALS  "" "" "Build ViSP tutorials" "" ON)
# Build apps as an option.
vp_check_subdirectories(VISP_CONTRIB_MODULES_PATH apps APPS_FOUND)
if(APPS_FOUND)
  VP_OPTION(BUILD_APPS  "" "" "Build ViSP apps" "" ON)
endif()
# Build deprecated functions as an option.
VP_OPTION(BUILD_DEPRECATED_FUNCTIONS  "" "" "Build deprecated functionalities" "" ON)
# Debug and trace cflags
set(ENABLE_DEBUG_LEVEL 0 CACHE STRING "Set a debug level value between 0 and 9")

if(ENABLE_DEBUG_LEVEL)
  if(ENABLE_DEBUG_LEVEL MATCHES "^([0-9]+)?$")
    set(VP_DEBUG_MODE ${CMAKE_MATCH_1})
    set(VP_DEBUG TRUE)
    set(VP_TRACE TRUE)
  else()
    set(VP_DEBUG_MODE 0)
  endif()
else()
  set(VP_DEBUG_MODE 0)
endif()

VP_OPTION(BUILD_WITH_STATIC_CRT  "" "" "Enables use of staticaly linked CRT for staticaly linked ViSP" "" ON IF MSVC)

# ----------------------------------------------------------------------------
# Build options
# ----------------------------------------------------------------------------
VP_OPTION(ENABLE_SOLUTION_FOLDERS "" "" "Solution folder in Visual Studio or in other IDEs" "" (MSVC_IDE OR CMAKE_GENERATOR MATCHES Xcode))
# Note that it is better to set ENABLE_MOMENTS_COMBINE_MATRICES to OFF
VP_OPTION(ENABLE_MOMENTS_COMBINE_MATRICES  "" "" "Use linear combination of matrices instead of linear combination of moments to compute interaction matrices." "ENABLE_MOMENTS_COMBINE_MATRICES" OFF)
VP_OPTION(ENABLE_TEST_WITHOUT_DISPLAY      "" "" "Don't use display feature when testing" "" ON)
VP_OPTION(ENABLE_FULL_DOC      "" "" "Build doc with internal classes that are by default not part of the doc" "" OFF)

if(ENABLE_SOLUTION_FOLDERS)
  set_property(GLOBAL PROPERTY USE_FOLDERS ON)
  set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")

=== demo/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Nicolas Melchior
#
#############################################################################

project(ViSP-demo)

cmake_minimum_required(VERSION 2.6)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(wireframe-simulator REQUIRED_DEPS visp_core visp_robot visp_vs visp_io visp_gui)

=== example/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(ViSP-examples)

cmake_minimum_required(VERSION 2.6)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(calibration              REQUIRED_DEPS visp_core visp_vision visp_io visp_gui)
visp_add_subdirectory(coin-simulator           REQUIRED_DEPS visp_core visp_robot visp_vs visp_ar visp_io)
visp_add_subdirectory(device/display           REQUIRED_DEPS visp_core visp_gui visp_io)
visp_add_subdirectory(device/framegrabber      REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(device/kinect            REQUIRED_DEPS visp_core visp_sensor visp_gui)
visp_add_subdirectory(device/laserscanner      REQUIRED_DEPS visp_core visp_sensor visp_io)
visp_add_subdirectory(device/light             REQUIRED_DEPS visp_core visp_robot visp_io)
visp_add_subdirectory(direct-visual-servoing   REQUIRED_DEPS visp_core visp_robot visp_visual_features visp_io visp_gui)
visp_add_subdirectory(homography               REQUIRED_DEPS visp_core visp_vision visp_io)
visp_add_subdirectory(image                    REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(key-point                REQUIRED_DEPS visp_core visp_vision visp_sensor visp_io visp_gui)
visp_add_subdirectory(manual                   REQUIRED_DEPS visp_core visp_sensor visp_vs visp_robot visp_ar visp_vision visp_io visp_gui)
visp_add_subdirectory(math                     REQUIRED_DEPS visp_core visp_vision visp_io)
visp_add_subdirectory(moments/image            REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/points           REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/polygon          REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(ogre-simulator           REQUIRED_DEPS visp_core visp_vision visp_ar visp_blob visp_io visp_gui)
visp_add_subdirectory(parse-argv               REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(pose-estimation          REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui)
visp_add_subdirectory(robot-simulator/afma6    REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/camera   REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/viper850 REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(servo-afma4              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-afma6              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-biclops            REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-franka             REQUIRED_DEPS visp_core visp_robot)
visp_add_subdirectory(servo-pioneer            REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-ptu46              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-viper650           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-viper850           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(tools                    REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(tracking                 REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(video                    REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(wireframe-simulator      REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)

=== modules/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file.
#
# Authors:
# Fabien Spindler
#
#############################################################################

if(NOT VISP_MODULES_PATH)
  set(VISP_MODULES_PATH "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

# extra modules are outside ViSP. Useful for contrib or specific additional modules
vp_glob_modules(${VISP_MODULES_PATH} EXTRA ${VISP_CONTRIB_MODULES_PATH})

=== tutorial/CMakeLists.txt ===
project(ViSP-tutorial)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(bridge/opencv                        REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(computer-vision                      REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui)
visp_add_subdirectory(grabber                              REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(detection/barcode                    REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(detection/face                       REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(detection/matching                   REQUIRED_DEPS visp_core visp_vision visp_io visp_gui)
visp_add_subdirectory(detection/object                     REQUIRED_DEPS visp_core visp_vision visp_mbt visp_io visp_gui)
visp_add_subdirectory(detection/tag                        REQUIRED_DEPS visp_core visp_detection visp_io visp_gui visp_sensor)
visp_add_subdirectory(image                                REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(imgproc/autothreshold                REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/brightness                   REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/connected-components         REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/contour                      REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/contrast-sharpening          REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/count-coins                  REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(imgproc/flood-fill                   REQUIRED_DEPS visp_core visp_io visp_gui visp_imgproc)
visp_add_subdirectory(robot/pioneer                        REQUIRED_DEPS visp_core visp_robot visp_vs visp_gui)
visp_add_subdirectory(simulator/image                      REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(trace                                REQUIRED_DEPS visp_core)
visp_add_subdirectory(tracking/blob                        REQUIRED_DEPS visp_core visp_blob visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/keypoint                    REQUIRED_DEPS visp_core visp_vision visp_klt visp_io visp_gui visp_sensor)
visp_add_subdirectory(tracking/model-based/generic         REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/stereo          REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/stereo-generic  REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/edges           REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/hybrid          REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/keypoint        REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/template-tracker            REQUIRED_DEPS visp_core visp_tt visp_io visp_gui)
visp_add_subdirectory(tracking/moving-edges                REQUIRED_DEPS visp_core visp_me visp_io visp_gui visp_sensor)
visp_add_subdirectory(visual-servo/ibvs                    REQUIRED_DEPS visp_core visp_robot visp_vs visp_blob visp_vision visp_io visp_gui visp_ar)

=== 3rdparty/apriltag/CMakeLists.txt ===
project(${APRILTAG_LIBRARY})

set(APRILTAG_MAJOR_VERSION 0 PARENT_SCOPE)
set(APRILTAG_MINOR_VERSION 9 PARENT_SCOPE)
set(APRILTAG_PATCH_VERSION 8 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB lib_srcs *.c common/*.c)
file(GLOB lib_hdrs *.h common/*.h common/sys/*.h)

vp_list_filterout(lib_srcs common/unionfind.c) # has no symbols
vp_list_filterout(lib_srcs common/getopt.c)    # useless and produces errors on uwp
vp_list_filterout(lib_hdrs common/getopt.h)    # useless and produces errors on uwp

add_library(${APRILTAG_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})
if(WIN32 AND MSVC)
  target_link_libraries (${APRILTAG_LIBRARY} ${PTHREADS_LIBRARY})
endif()

if(C99_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C99_C_FLAGS}")
endif()

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
  endif()
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${APRILTAG_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${APRILTAG_LIBRARY}
  PROPERTIES OUTPUT_NAME ${APRILTAG_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${APRILTAG_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${APRILTAG_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${APRILTAG_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

if(MSVC)
  vp_set_source_file_compile_flag(apriltag.c /wd"4018" /wd"4305" /wd"4334" /wd"4244")
  vp_set_source_file_compile_flag(apriltag_quad_thresh.c /wd"4018" /wd"4244")
  vp_set_source_file_compile_flag(common/g2d.c /wd"4244")
  vp_set_source_file_compile_flag(common/getopt.c /wd"4018" /wd"4244" /wd"4996")
  vp_set_source_file_compile_flag(common/homography.c /wd"4244")
  vp_set_source_file_compile_flag(common/image_f32.c /wd"4244")
  vp_set_source_file_compile_flag(common/image_u8.c /wd"4244")
  vp_set_source_file_compile_flag(common/image_u8x3.c /wd"4244")
  vp_set_source_file_compile_flag(common/matd.c /wd"4018" /wd"4244")
  vp_set_source_file_compile_flag(common/pjpeg-idct.c /wd"4244")
  vp_set_source_file_compile_flag(common/pjpeg.c /wd4018 /wd"4267")
  vp_set_source_file_compile_flag(common/string_util.c /wd"4996" /wd"4267")
  vp_set_source_file_compile_flag(common/time_util.c /wd"4244")
  vp_set_source_file_compile_flag(common/times.c /wd"4244")
  vp_set_source_file_compile_flag(common/zhash.c /wd"4267")
  vp_set_source_file_compile_flag(common/zmaxheap.c /wd"4098" /wd"4244")
  vp_set_source_file_compile_flag(common/workerpool.c /wd"4018" /wd"4244")
  vp_set_source_file_compile_flag(common/pam.c /wd"4018")
  vp_set_source_file_compile_flag(common/string_util.c /wd"4018" /wd"4267" /wd"4996")
  vp_set_source_file_compile_flag(tag16h5.c /wd"4996")
  vp_set_source_file_compile_flag(tag25h7.c /wd"4996")
  vp_set_source_file_compile_flag(tag25h9.c /wd"4996")
  vp_set_source_file_compile_flag(tag36artoolkit.c /wd"4996")
  vp_set_source_file_compile_flag(tag36h10.c /wd"4996")
  vp_set_source_file_compile_flag(tag36h11.c /wd"4996")
endif()

=== 3rdparty/atidaq/CMakeLists.txt ===
project(${ATIDAQ_LIBRARY})

set(ATIDAQ_MAJOR_VERSION 1 PARENT_SCOPE)
set(ATIDAQ_MINOR_VERSION 0 PARENT_SCOPE)
set(ATIDAQ_PATCH_VERSION 6 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB lib_srcs *.c)
file(GLOB lib_hdrs *.h)

vp_list_filterout(lib_srcs xmltok_impl.c)
vp_list_filterout(lib_hdrs xmltok_impl.h)
vp_list_filterout(lib_srcs xmltok_ns.c)
vp_list_filterout(lib_srcs events.c)

add_library(${ATIDAQ_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
  endif()
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${ATIDAQ_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

vp_warnings_disable(CMAKE_C_FLAGS -Wunused-parameter)

set_target_properties(${ATIDAQ_LIBRARY}
  PROPERTIES OUTPUT_NAME ${ATIDAQ_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${ATIDAQ_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${ATIDAQ_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${ATIDAQ_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

=== 3rdparty/clapack/CMakeLists.txt ===
project(${LAPACK_LIBRARY} C)

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
  endif()
endif()

set(LAPACK_MAJOR_VERSION 3 PARENT_SCOPE)
set(LAPACK_MINOR_VERSION 2 PARENT_SCOPE)
set(LAPACK_PATCH_VERSION 1 PARENT_SCOPE)

if(WIN32 AND MSVC)
  add_definitions(-DMSDOS -DNO_ISATTY)
endif()

file(GLOB lib_srcs src/*.c blas/*.c install/*.c f2c/*.c)
file(GLOB lib_incs include/*.h)

add_library(${LAPACK_LIBRARY} STATIC ${lib_srcs} ${lib_incs})
vp_target_include_directories(${LAPACK_LIBRARY} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${LAPACK_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${LAPACK_LIBRARY}
  PROPERTIES OUTPUT_NAME ${LAPACK_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${LAPACK_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${LAPACK_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${LAPACK_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

if(MSVC)
  # Disable Visual C++ warnings
  foreach(f ${lib_srcs})
    vp_set_source_file_compile_flag(${f} /wd"4244" /wd"4267" /wd"4273" /wd"4554" /wd"4996")
  endforeach()
  vp_set_source_file_compile_flag(f2c/pow_ii.c /wd"4723")
else()
  foreach(f ${lib_srcs})
    vp_set_source_file_compile_flag(${f} -Wno-logical-op-parentheses -Wno-shift-op-parentheses -Wno-parentheses -Wno-format-extra-args -Wno-format)
  endforeach()
endif()

=== 3rdparty/clipper/CMakeLists.txt ===
project(${CLIPPER_LIBRARY})

set(CLIPPER_MAJOR_VERSION 6 PARENT_SCOPE)
set(CLIPPER_MINOR_VERSION 4 PARENT_SCOPE)
set(CLIPPER_PATCH_VERSION 2 PARENT_SCOPE)

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})

file(GLOB lib_srcs *.cpp)
file(GLOB lib_hdrs *.hpp)

add_library(${CLIPPER_LIBRARY} STATIC ${lib_srcs} ${lib_hdrs})

if(UNIX)
  if(CMAKE_COMPILER_IS_GNUCXX OR CV_ICC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
  endif()
endif()

if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${CLIPPER_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${CLIPPER_LIBRARY}
  PROPERTIES OUTPUT_NAME ${CLIPPER_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${CLIPPER_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${CLIPPER_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${CLIPPER_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

=== 3rdparty/pthreads-win32/CMakeLists.txt ===
project(${PTHREADS_LIBRARY})

set(PTHREADS_MAJOR_VERSION 2 PARENT_SCOPE)
set(PTHREADS_MINOR_VERSION 9 PARENT_SCOPE)
set(PTHREADS_PATCH_VERSION 1 PARENT_SCOPE)

set(PTHREAD_API
  pthread.h
  sched.h
  semaphore.h)

source_group(PTHREAD_API FILES ${PTHREAD_API})

set(PTHREAD_HEADERS
  config.h
  implement.h
  need_errno.h)

set(PTHREAD_STATIC_SOURCES
  pthread_attr_init.c
  pthread_attr_destroy.c
  pthread_attr_getdetachstate.c
  pthread_attr_setdetachstate.c
  pthread_attr_getstackaddr.c
  pthread_attr_setstackaddr.c
  pthread_attr_getstacksize.c
  pthread_attr_setstacksize.c
  pthread_attr_getscope.c
  pthread_attr_setscope.c
  pthread_attr_setschedpolicy.c
  pthread_attr_getschedpolicy.c
  pthread_attr_setschedparam.c
  pthread_attr_getschedparam.c
  pthread_attr_setinheritsched.c
  pthread_attr_getinheritsched.c
  pthread_barrier_init.c
  pthread_barrier_destroy.c
  pthread_barrier_wait.c
  pthread_barrierattr_init.c
  pthread_barrierattr_destroy.c
  pthread_barrierattr_setpshared.c
  pthread_barrierattr_getpshared.c
  pthread_setcancelstate.c
  pthread_setcanceltype.c
  pthread_testcancel.c
  pthread_cancel.c
  cleanup.c
  pthread_condattr_destroy.c
  pthread_condattr_getpshared.c
  pthread_condattr_init.c
  pthread_condattr_setpshared.c
  pthread_cond_destroy.c
  pthread_cond_init.c
  pthread_cond_signal.c
  pthread_cond_wait.c
  create.c
  dll.c
  autostatic.c
  errno.c
  pthread_exit.c
  fork.c
  global.c
  pthread_mutex_init.c
  pthread_mutex_destroy.c
  pthread_mutexattr_init.c
  pthread_mutexattr_destroy.c
  pthread_mutexattr_getpshared.c
  pthread_mutexattr_setpshared.c
  pthread_mutexattr_settype.c
  pthread_mutexattr_gettype.c
  pthread_mutexattr_setrobust.c
  pthread_mutexattr_getrobust.c
  pthread_mutex_lock.c
  pthread_mutex_timedlock.c
  pthread_mutex_unlock.c
  pthread_mutex_trylock.c
  pthread_mutex_consistent.c
  pthread_mutexattr_setkind_np.c
  pthread_mutexattr_getkind_np.c
  pthread_getw32threadhandle_np.c
  pthread_getunique_np.c
  pthread_delay_np.c
  pthread_num_processors_np.c
  pthread_win32_attach_detach_np.c
  pthread_equal.c
  pthread_getconcurrency.c
  pthread_once.c
  pthread_self.c
  pthread_setconcurrency.c
  pthread_rwlock_init.c
  pthread_rwlock_destroy.c
  pthread_rwlockattr_init.c
  pthread_rwlockattr_destroy.c
  pthread_rwlockattr_getpshared.c
  pthread_rwlockattr_setpshared.c
  pthread_rwlock_rdlock.c
  pthread_rwlock_wrlock.c
  pthread_rwlock_unlock.c
  pthread_rwlock_tryrdlock.c
  pthread_rwlock_trywrlock.c
  pthread_setschedparam.c
  pthread_getschedparam.c
  pthread_timechange_handler_np.c
  ptw32_is_attr.c
  ptw32_processInitialize.c
  ptw32_processTerminate.c
  ptw32_threadStart.c
  ptw32_threadDestroy.c
  ptw32_tkAssocCreate.c
  ptw32_tkAssocDestroy.c
  ptw32_callUserDestroyRoutines.c
  ptw32_timespec.c
  ptw32_throw.c
  ptw32_getprocessors.c
  ptw32_calloc.c
  ptw32_new.c
  ptw32_reuse.c
  ptw32_rwlock_check_need_init.c
  ptw32_cond_check_need_init.c
  ptw32_mutex_check_need_init.c
  ptw32_semwait.c
  ptw32_relmillisecs.c
  ptw32_MCS_lock.c
  sched_get_priority_max.c
  sched_get_priority_min.c
  sched_setscheduler.c
  sched_getscheduler.c
  sched_yield.c
  sem_init.c
  sem_destroy.c
  sem_trywait.c
  sem_timedwait.c
  sem_wait.c
  sem_post.c
  sem_post_multiple.c
  sem_getvalue.c
  sem_open.c
  sem_close.c
  sem_unlink.c
  signal.c
  pthread_kill.c
  ptw32_spinlock_check_need_init.c
  pthread_spin_init.c
  pthread_spin_destroy.c
  pthread_spin_lock.c
  pthread_spin_unlock.c
  pthread_spin_trylock.c
  pthread_detach.c
  pthread_join.c
  pthread_key_create.c
  pthread_key_delete.c
  pthread_setspecific.c
  pthread_getspecific.c
  w32_CancelableWait.c)

add_definitions( -DPTW32_BUILD_INLINED )

vp_include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_library(${PTHREADS_LIBRARY} STATIC ${PTHREAD_STATIC_SOURCES} ${PTHREAD_API} ${PTHREAD_HEADERS})

if(CMAKE_COMPILER_IS_GNUCXX AND UNIX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

#set_target_properties(${PTHREADS_LIBRARY} PROPERTIES PUBLIC_HEADER "${PTHREAD_API}")
if(ENABLE_SOLUTION_FOLDERS)
  set_target_properties(${PTHREADS_LIBRARY} PROPERTIES FOLDER "3rdparty")
endif()

set_target_properties(${PTHREADS_LIBRARY}
  PROPERTIES OUTPUT_NAME ${PTHREADS_LIBRARY}
  DEBUG_POSTFIX "${VISP_DEBUG_POSTFIX}"
  COMPILE_PDB_NAME ${PTHREADS_LIBRARY}
  COMPILE_PDB_NAME_DEBUG "${PTHREADS_LIBRARY}${VISP_DEBUG_POSTFIX}"
  ARCHIVE_OUTPUT_DIRECTORY ${VISP_3P_LIBRARY_OUTPUT_PATH}
  )
target_compile_definitions(${PTHREADS_LIBRARY} PUBLIC PTW32_STATIC_LIB HAVE_PTW32_CONFIG_H)
target_include_directories(${PTHREADS_LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
#set_property(TARGET ${PTHREADS_LIBRARY} APPEND PROPERTY
#  INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR})

if(NOT BUILD_SHARED_LIBS)
  vp_install_target(${PTHREADS_LIBRARY} EXPORT VISPModules ARCHIVE DESTINATION ${VISP_3P_LIB_INSTALL_PATH} COMPONENT dev)
endif()

if(MSVC)
  vp_set_source_file_compile_flag(pthread_spin_lock.c /wd"4013")
  vp_set_source_file_compile_flag(pthread_spin_trylock.c /wd"4013")
  vp_set_source_file_compile_flag(pthread_win32_attach_detach_np.c /wd"4101")
  vp_set_source_file_compile_flag(ptw32_getprocessors.c /wd"4013")
endif()

=== 3rdparty/pthreads-win32/Makefile ===
# This makefile is compatible with MS nmake and can be used as a
# replacement for buildlib.bat. I've changed the target from an ordinary dll
# (/LD) to a debugging dll (/LDd).
# 
# The variables $DLLDEST and $LIBDEST hold the destination directories for the
# dll and the lib, respectively. Probably all that needs to change is $DEVROOT.


# DLL_VER:
# See pthread.h and README - This number is computed as 'current - age'
DLL_VER	= 2
DLL_VERD= $(DLL_VER)d

DEVROOT	= C:\pthreads

DLLDEST	= $(DEVROOT)\dll
LIBDEST	= $(DEVROOT)\lib
HDRDEST	= $(DEVROOT)\include

DLLS	= pthreadVCE$(DLL_VER).dll pthreadVSE$(DLL_VER).dll pthreadVC$(DLL_VER).dll \
		  pthreadVCE$(DLL_VERD).dll pthreadVSE$(DLL_VERD).dll pthreadVC$(DLL_VERD).dll
INLINED_STAMPS	= pthreadVCE$(DLL_VER).stamp pthreadVSE$(DLL_VER).stamp pthreadVC$(DLL_VER).stamp \
				  pthreadVCE$(DLL_VERD).stamp pthreadVSE$(DLL_VERD).stamp pthreadVC$(DLL_VERD).stamp
STATIC_STAMPS	= pthreadVCE$(DLL_VER).static pthreadVSE$(DLL_VER).static pthreadVC$(DLL_VER).static \
				  pthreadVCE$(DLL_VERD).static pthreadVSE$(DLL_VERD).static pthreadVC$(DLL_VERD).static

CC	= cl
CPPFLAGS = /I. /DHAVE_PTW32_CONFIG_H
XCFLAGS = /W3 /MD /nologo
CFLAGS	= /O2 /Ob2 $(XCFLAGS)
CFLAGSD	= /Z7 $(XCFLAGS)

# Uncomment this if config.h defines RETAIN_WSALASTERROR
#XLIBS = wsock32.lib

# Default cleanup style
CLEANUP	= __CLEANUP_C

# C++ Exceptions
VCEFLAGS	= /EHsc /TP $(CPPFLAGS) $(CFLAGS)
VCEFLAGSD	= /EHsc /TP $(CPPFLAGS) $(CFLAGSD)
#Structured Exceptions
VSEFLAGS	= $(CPPFLAGS) $(CFLAGS)
VSEFLAGSD	= $(CPPFLAGS) $(CFLAGSD)
#C cleanup code
VCFLAGS		= $(CPPFLAGS) $(CFLAGS)
VCFLAGSD	= $(CPPFLAGS) $(CFLAGSD)

DLL_INLINED_OBJS = \
		pthread.obj \
		version.res

# Aggregate modules for inlinability
DLL_OBJS	= \
		attr.obj \
		barrier.obj \
		cancel.obj \
		cleanup.obj \
		condvar.obj \
		create.obj \
		dll.obj \
		autostatic.obj \
		errno.obj \
		exit.obj \
		fork.obj \
		global.obj \
		misc.obj \
		mutex.obj \
		nonportable.obj \
		private.obj \
		rwlock.obj \
		sched.obj \
		semaphore.obj \
		signal.obj \
		spin.obj \
		sync.obj \
		tsd.obj \
		version.res

# Separate modules for minimising the size of statically linked images
SMALL_STATIC_OBJS	= \
		pthread_attr_init.obj \
		pthread_attr_destroy.obj \
		pthread_attr_getdetachstate.obj \
		pthread_attr_setdetachstate.obj \
		pthread_attr_getstackaddr.obj \
		pthread_attr_setstackaddr.obj \
		pthread_attr_getstacksize.obj \
		pthread_attr_setstacksize.obj \
		pthread_attr_getscope.obj \
		pthread_attr_setscope.obj \
		pthread_attr_setschedpolicy.obj \
		pthread_attr_getschedpolicy.obj \
		pthread_attr_setschedparam.obj \
		pthread_attr_getschedparam.obj \
		pthread_attr_setinheritsched.obj \
		pthread_attr_getinheritsched.obj \
		pthread_barrier_init.obj \
		pthread_barrier_destroy.obj \
		pthread_barrier_wait.obj \
		pthread_barrierattr_init.obj \
		pthread_barrierattr_destroy.obj \
		pthread_barrierattr_setpshared.obj \
		pthread_barrierattr_getpshared.obj \
		pthread_setcancelstate.obj \
		pthread_setcanceltype.obj \
		pthread_testcancel.obj \
		pthread_cancel.obj \
		cleanup.obj \
		pthread_condattr_destroy.obj \
		pthread_condattr_getpshared.obj \
		pthread_condattr_init.obj \
		pthread_condattr_setpshared.obj \
		pthread_cond_destroy.obj \
		pthread_cond_init.obj \
		pthread_cond_signal.obj \
		pthread_cond_wait.obj \
		create.obj \
		dll.obj \
		autostatic.obj \
		errno.obj \
		pthread_exit.obj \
		fork.obj \
		global.obj \
		pthread_mutex_init.obj \
		pthread_mutex_destroy.obj \
		pthread_mutexattr_init.obj \
		pthread_mutexattr_destroy.obj \
		pthread_mutexattr_getpshared.obj \
		pthread_mutexattr_setpshared.obj \
		pthread_mutexattr_settype.obj \
		pthread_mutexattr_gettype.obj \
		pthread_mutexattr_setrobust.obj \
		pthread_mutexattr_getrobust.obj \
		pthread_mutex_lock.obj \
		pthread_mutex_timedlock.obj \
		pthread_mutex_unlock.obj \
		pthread_mutex_trylock.obj \
		pthread_mutex_consistent.obj \
		pthread_mutexattr_setkind_np.obj \
		pthread_mutexattr_getkind_np.obj \
		pthread_getw32threadhandle_np.obj \
		pthread_getunique_np.obj \
		pthread_delay_np.obj \
		pthread_num_processors_np.obj \
		pthread_win32_attach_detach_np.obj \
		pthread_equal.obj \
		pthread_getconcurrency.obj \
		pthread_once.obj \
		pthread_self.obj \
		pthread_setconcurrency.obj \
		pthread_rwlock_init.obj \
		pthread_rwlock_destroy.obj \
		pthread_rwlockattr_init.obj \
		pthread_rwlockattr_destroy.obj \
		pthread_rwlockattr_getpshared.obj \
		pthread_rwlockattr_setpshared.obj \
		pthread_rwlock_rdlock.obj \
		pthread_rwlock_wrlock.obj \
		pthread_rwlock_unlock.obj \
		pthread_rwlock_tryrdlock.obj \
		pthread_rwlock_trywrlock.obj \
		pthread_setschedparam.obj \
		pthread_getschedparam.obj \
		pthread_timechange_handler_np.obj \
		ptw32_is_attr.obj \
		ptw32_processInitialize.obj \
		ptw32_processTerminate.obj \
		ptw32_threadStart.obj \
		ptw32_threadDestroy.obj \
		ptw32_tkAssocCreate.obj \
		ptw32_tkAssocDestroy.obj \
		ptw32_callUserDestroyRoutines.obj \
		ptw32_timespec.obj \
		ptw32_throw.obj \
		ptw32_getprocessors.obj \
		ptw32_calloc.obj \
		ptw32_new.obj \
		ptw32_reuse.obj \
		ptw32_rwlock_check_need_init.obj \
		ptw32_cond_check_need_init.obj \
		ptw32_mutex_check_need_init.obj \
		ptw32_semwait.obj \
		ptw32_relmillisecs.obj \
		ptw32_MCS_lock.obj \
		sched_get_priority_max.obj \
		sched_get_priority_min.obj \
		sched_setscheduler.obj \
		sched_getscheduler.obj \
		sched_yield.obj \
		sem_init.obj \
		sem_destroy.obj \
		sem_trywait.obj \
		sem_timedwait.obj \
		sem_wait.obj \
		sem_post.obj \
		sem_post_multiple.obj \
		sem_getvalue.obj \
		sem_open.obj \
		sem_close.obj \
		sem_unlink.obj \
		signal.obj \
		pthread_kill.obj \
		ptw32_spinlock_check_need_init.obj \
		pthread_spin_init.obj \
		pthread_spin_destroy.obj \
		pthread_spin_lock.obj \
		pthread_spin_unlock.obj \
		pthread_spin_trylock.obj \
		pthread_detach.obj \
		pthread_join.obj \
		pthread_key_create.obj \
		pthread_key_delete.obj \
		pthread_setspecific.obj \
		pthread_getspecific.obj \
		w32_CancelableWait.obj \
		version.res

INCL	= config.h implement.h semaphore.h pthread.h need_errno.h

ATTR_SRCS	= \
		pthread_attr_init.c \
		pthread_attr_destroy.c \
		pthread_attr_getdetachstate.c \
		pthread_attr_setdetachstate.c \
		pthread_attr_getstackaddr.c \
		pthread_attr_setstackaddr.c \
		pthread_attr_getstacksize.c \
		pthread_attr_setstacksize.c \
		pthread_attr_getscope.c \
		pthread_attr_setscope.c

BARRIER_SRCS = \
		pthread_barrier_init.c \
		pthread_barrier_destroy.c \
		pthread_barrier_wait.c \
		pthread_barrierattr_init.c \
		pthread_barrierattr_destroy.c \
		pthread_barrierattr_setpshared.c \
		pthread_barrierattr_getpshared.c

CANCEL_SRCS	= \
		pthread_setcancelstate.c \
		pthread_setcanceltype.c \
		pthread_testcancel.c \
		pthread_cancel.c 

CONDVAR_SRCS	= \
		ptw32_cond_check_need_init.c \
		pthread_condattr_destroy.c \
		pthread_condattr_getpshared.c \
		pthread_condattr_init.c \
		pthread_condattr_setpshared.c \
		pthread_cond_destroy.c \
		pthread_cond_init.c \
		pthread_cond_signal.c \
		pthread_cond_wait.c

EXIT_SRCS	= \
		pthread_exit.c

MISC_SRCS	= \
		pthread_equal.c \
		pthread_getconcurrency.c \
		pthread_kill.c \
		pthread_once.c \
		pthread_self.c \
		pthread_setconcurrency.c \
		ptw32_calloc.c \
		ptw32_MCS_lock.c \
		ptw32_new.c \
		ptw32_reuse.c \
		ptw32_relmillisecs.c \
		w32_CancelableWait.c

MUTEX_SRCS	= \
		ptw32_mutex_check_need_init.c \
		pthread_mutex_init.c \
		pthread_mutex_destroy.c \
		pthread_mutexattr_init.c \
		pthread_mutexattr_destroy.c \
		pthread_mutexattr_getpshared.c \
		pthread_mutexattr_setpshared.c \
		pthread_mutexattr_settype.c \
		pthread_mutexattr_gettype.c \
		pthread_mutexattr_setrobust.c \
		pthread_mutexattr_getrobust.c \
		pthread_mutex_lock.c \
		pthread_mutex_timedlock.c \
		pthread_mutex_unlock.c \
		pthread_mutex_trylock.c \
		pthread_mutex_consistent.c

NONPORTABLE_SRCS = \
		pthread_mutexattr_setkind_np.c \
		pthread_mutexattr_getkind_np.c \
		pthread_getw32threadhandle_np.c \
		pthread_getunique_np.c \
		pthread_delay_np.c \
		pthread_num_processors_np.c \
		pthread_win32_attach_detach_np.c \
		pthread_timechange_handler_np.c 

PRIVATE_SRCS	= \
		ptw32_is_attr.c \
		ptw32_processInitialize.c \
		ptw32_processTerminate.c \
		ptw32_threadStart.c \
		ptw32_threadDestroy.c \
		ptw32_tkAssocCreate.c \
		ptw32_tkAssocDestroy.c \
		ptw32_callUserDestroyRoutines.c \
		ptw32_semwait.c \
		ptw32_timespec.c \
		ptw32_throw.c \
		ptw32_getprocessors.c

RWLOCK_SRCS	= \
		ptw32_rwlock_check_need_init.c \
		ptw32_rwlock_cancelwrwait.c \
		pthread_rwlock_init.c \
		pthread_rwlock_destroy.c \
		pthread_rwlockattr_init.c \
		pthread_rwlockattr_destroy.c \
		pthread_rwlockattr_getpshared.c \
		pthread_rwlockattr_setpshared.c \
		pthread_rwlock_rdlock.c \
		pthread_rwlock_timedrdlock.c \
		pthread_rwlock_wrlock.c \
		pthread_rwlock_timedwrlock.c \
		pthread_rwlock_unlock.c \
		pthread_rwlock_tryrdlock.c \
		pthread_rwlock_trywrlock.c

SCHED_SRCS	= \
		pthread_attr_setschedpolicy.c \
		pthread_attr_getschedpolicy.c \
		pthread_attr_setschedparam.c \
		pthread_attr_getschedparam.c \
		pthread_attr_setinheritsched.c \
		pthread_attr_getinheritsched.c \
		pthread_setschedparam.c \
		pthread_getschedparam.c \
		sched_get_priority_max.c \
		sched_get_priority_min.c \
		sched_setscheduler.c \
		sched_getscheduler.c \
		sched_yield.c

SEMAPHORE_SRCS = \
		sem_init.c \
		sem_destroy.c \
		sem_trywait.c \
		sem_timedwait.c \
		sem_wait.c \
		sem_post.c \
		sem_post_multiple.c \
		sem_getvalue.c \
		sem_open.c \
		sem_close.c \
		sem_unlink.c

SPIN_SRCS	= \
		ptw32_spinlock_check_need_init.c \
		pthread_spin_init.c \
		pthread_spin_destroy.c \
		pthread_spin_lock.c \
		pthread_spin_unlock.c \
		pthread_spin_trylock.c

SYNC_SRCS	= \
		pthread_detach.c \
		pthread_join.c

TSD_SRCS	= \
		pthread_key_create.c \
		pthread_key_delete.c \
		pthread_setspecific.c \
		pthread_getspecific.c


help:
	@ echo Run one of the following command lines:
	@ echo nmake clean VCE   (to build the MSVC dll with C++ exception handling)
	@ echo nmake clean VSE   (to build the MSVC dll with structured exception handling)
	@ echo nmake clean VC    (to build the MSVC dll with C cleanup code)
	@ echo nmake clean VCE-inlined   (to build the MSVC inlined dll with C++ exception handling)
	@ echo nmake clean VSE-inlined   (to build the MSVC inlined dll with structured exception handling)
	@ echo nmake clean VC-inlined    (to build the MSVC inlined dll with C cleanup code)
	@ echo nmake clean VC-static     (to build the MSVC static lib with C cleanup code)
	@ echo nmake clean VCE-debug   (to build the debug MSVC dll with C++ exception handling)
	@ echo nmake clean VSE-debug   (to build the debug MSVC dll with structured exception handling)
	@ echo nmake clean VC-debug    (to build the debug MSVC dll with C cleanup code)
	@ echo nmake clean VCE-inlined-debug   (to build the debug MSVC inlined dll with C++ exception handling)
	@ echo nmake clean VSE-inlined-debug   (to build the debug MSVC inlined dll with structured exception handling)
	@ echo nmake clean VC-inlined-debug    (to build the debug MSVC inlined dll with C cleanup code)
	@ echo nmake clean VC-static-debug     (to build the debug MSVC static lib with C cleanup code)

all:
	@ $(MAKE) /E clean VCE-inlined
	@ $(MAKE) /E clean VSE-inlined
	@ $(MAKE) /E clean VC-inlined
	@ $(MAKE) /E clean VCE-inlined-debug
	@ $(MAKE) /E clean VSE-inlined-debug
	@ $(MAKE) /E clean VC-inlined-debug

VCE:
	@ $(MAKE) /E /nologo EHFLAGS="$(VCEFLAGS)" CLEANUP=__CLEANUP_CXX pthreadVCE$(DLL_VER).dll

VCE-debug:
	@ $(MAKE) /E /nologo EHFLAGS="$(VCEFLAGSD)" CLEANUP=__CLEANUP_CXX pthreadVCE$(DLL_VERD).dll

VSE:
	@ $(MAKE) /E /nologo EHFLAGS="$(VSEFLAGS)" CLEANUP=__CLEANUP_SEH pthreadVSE$(DLL_VER).dll

VSE-debug:
	@ $(MAKE) /E /nologo EHFLAGS="$(VSEFLAGSD)" CLEANUP=__CLEANUP_SEH pthreadVSE$(DLL_VERD).dll

VC:
	@ $(MAKE) /E /nologo EHFLAGS="$(VCFLAGS)" CLEANUP=__CLEANUP_C pthreadVC$(DLL_VER).dll

VC-debug:

=== demo/wireframe-simulator/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2017 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file.
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(demo-wireframe-simulator)

cmake_minimum_required(VERSION 2.8)

find_package(VISP REQUIRED visp_core visp_robot visp_vs visp_io visp_gui)

# SOURCE variable corresponds to the list of all the sources to build binaries.
# The generate binary comes by removing the .cpp extension to
# the source name.
#
# If you want to add/remove a source, modify here
set(demo_cpp
  servoSimu4Points.cpp
  servoSimuCylinder.cpp
  servoSimuSphere.cpp
)

foreach(cpp ${demo_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "demos")
  endif()
endforeach()

# Add test
# To run some of these tests don't forget to set VISP_INPUT_IMAGE_PATH
# environment variable to the ViSP test sequences location.
# To get these sequence download ViSP-images.tar.gz from
# https://visp.inria.fr/download/
add_test(servoSimu4Points servoSimu4Points -d)
add_test(servoSimuCylinder servoSimuCylinder -d)
add_test(servoSimuSphere servoSimuSphere -d)

=== debian/changelog ===
visp (3.1.0-2) unstable; urgency=medium

  * remove useless patches
  * Introduce new patches to fix issues. Closes: #886140, #886141
  * Update to last version of Debian policy

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Sun, 14 Jan 2018 22:28:11 +0100

visp (3.1.0-1) unstable; urgency=medium

  * Remove 3.0.1 patches
  * New upstream version 3.1.0
  * Update debian material for visp 3.1.0
    Fix debian issues: Closes: #856703, #878937, #871414
  * Add patches for visp 3.1.0
  * Add libvisp-imgproc-dev
  * Fix lintian warnings
  * Remove Coin3D usage since it produces a segfault in mbt examples
    when calling SoDB::Init()

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Thu, 28 Dec 2017 10:31:31 +0100

=== debian/control ===
Source: visp
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>, Fabien Spindler <Fabien.Spindler@inria.fr>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
	cmake,
	doxygen,
	libdc1394-22-dev [linux-any],
	libdmtx-dev,
	libeigen3-dev,
	libgsl-dev,
	libjpeg-dev,
	liblapack-dev,
	libogre-1.9-dev,
	libopencv-dev,
	libpng-dev,
	libv4l-dev [linux-any],
	libx11-dev,
	libxml2-dev,
	libzbar-dev,
	visp-images-data
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/visp.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/visp.git
Homepage: https://visp.inria.fr

Package: libvisp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	libvisp-ar-dev (= ${binary:Version}),
	libvisp-blob-dev (= ${binary:Version}),
	libvisp-core-dev (= ${binary:Version}),
	libvisp-detection-dev (= ${binary:Version}),
	libvisp-gui-dev (= ${binary:Version}),
	libvisp-io-dev (= ${binary:Version}),
	libvisp-imgproc-dev (= ${binary:Version}),
	libvisp-klt-dev (= ${binary:Version}),
	libvisp-mbt-dev (= ${binary:Version}),
	libvisp-me-dev (= ${binary:Version}),
	libvisp-robot-dev (= ${binary:Version}),
	libvisp-sensor-dev (= ${binary:Version}),
	libvisp-tt-dev (= ${binary:Version}),
	libvisp-tt-mi-dev (= ${binary:Version}),
	libvisp-visual-features-dev (= ${binary:Version}),
	libvisp-vision-dev (= ${binary:Version}),
	libvisp-vs-dev (= ${binary:Version})
Suggests: libvisp-doc
Description: development files for ViSP
 This is a metapackage providing development package necessary for
 development of ViSP (Visual Servoing Platform).
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, 
	libvisp-core3.1 (= ${binary:Version}),
	libeigen3-dev,
	libgsl-dev,
	liblapack-dev,
	libopencv-dev,
	libxml2-dev
Description: development files for libvisp-core
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) core.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core3.1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: visual servoing platform core library
 This package contains the ViSP (Visual Servoing Platform) core runtime
 libraries.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core3.1-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libvisp-core3.1 (= ${binary:Version})
Description: Debugging symbol for libvisp-core3.1
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) core library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-gui3.1 (= ${binary:Version}),
	libx11-dev
Description: development files for libvisp-gui
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) graphical user
 interface (GUI) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui3.1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.1 (= ${binary:Version})
Description: visual servoing platform gui library
 This package contains the ViSP (Visual Servoing Platform) graphical user
 interface (GUI) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui3.1-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libvisp-gui3.1 (= ${binary:Version})
Description: Debugging symbol for libvisp-gui3.1
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) graphical user interface library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-imgproc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-imgproc3.1 (= ${binary:Version})
Description: development files for libvisp-imgproc
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) image processing
 library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-imgproc3.1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.1 (= ${binary:Version})
Description: visual servoing platform imgproc library
 This package contains the ViSP (Visual Servoing Platform) image processing
 runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-imgproc3.1-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, libvisp-imgproc3.1 (= ${binary:Version})
Description: Debugging symbol for libvisp-imgproc3.1
 This package contains detached debugging symbol for ViSP
 (Visual Servoing Platform) image processing library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities.
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-io3.1 (= ${binary:Version}),
	libjpeg-dev,
	libpng-dev
Description: development files for libvisp-io
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) input/output
 (io) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io3.1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.1 (= ${binary:Version})
Description: visual servoing platform io library
 This package contains the ViSP (Visual Servoing Platform) input/output
 (io) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

# Retrieve environment information.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Linux-specific stuff (dc1394, v4l, ois only available on linux)
ifeq ($(DEB_HOST_ARCH_OS),linux)
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=ON -DUSE_V4L2=ON -DUSE_OIS=ON
else
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=OFF -DUSE_V4L2=OFF -DUSE_OIS=OFF
endif

# CMake flags
CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_INSTALL_INCLUDEDIR="include/$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_INSTALL_LIBDIR="lib/$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_EXE_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release \
	-DUSE_COIN3D=OFF \
	$(CMAKE_ARCH_FLAGS)

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_clean:
	dh_clean -O--buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_build-indep:
	dh_auto_build -- visp_doc # Generate Doxygen HTML documentation.

override_dh_installdocs:
	dh_installdocs -X.md5

override_dh_strip:
	dh_strip -plibvisp-ar3.1 --dbg-package=libvisp-ar3.1-dbg
	dh_strip -plibvisp-blob3.1 --dbg-package=libvisp-blob3.1-dbg
	dh_strip -plibvisp-core3.1 --dbg-package=libvisp-core3.1-dbg
	dh_strip -plibvisp-detection3.1 --dbg-package=libvisp-detection3.1-dbg
	dh_strip -plibvisp-gui3.1 --dbg-package=libvisp-gui3.1-dbg
	dh_strip -plibvisp-imgproc3.1 --dbg-package=libvisp-imgproc3.1-dbg
	dh_strip -plibvisp-io3.1 --dbg-package=libvisp-io3.1-dbg
	dh_strip -plibvisp-klt3.1 --dbg-package=libvisp-klt3.1-dbg
	dh_strip -plibvisp-mbt3.1 --dbg-package=libvisp-mbt3.1-dbg
	dh_strip -plibvisp-me3.1 --dbg-package=libvisp-me3.1-dbg
	dh_strip -plibvisp-robot3.1 --dbg-package=libvisp-robot3.1-dbg
	dh_strip -plibvisp-sensor3.1 --dbg-package=libvisp-sensor3.1-dbg
	dh_strip -plibvisp-visual-features3.1 --dbg-package=libvisp-visual-features3.1-dbg
	dh_strip -plibvisp-vision3.1 --dbg-package=libvisp-vision3.1-dbg
	dh_strip -plibvisp-vs3.1 --dbg-package=libvisp-vs3.1-dbg
	dh_strip -plibvisp-tt3.1 --dbg-package=libvisp-tt3.1-dbg
	dh_strip -plibvisp-tt-mi3.1 --dbg-package=libvisp-tt-mi3.1-dbg
	dh_strip

# Due to numerical imprecision, some tests are failing on ia64.
# This is not a critical issue so we let the testing fail on this
# architecture for now.
# See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=723803
ifeq ($(DEB_HOST_ARCH),ia64)
  DH_AUTOTEST_CAN_FAIL=true
else
  DH_AUTOTEST_CAN_FAIL=false
endif

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	export VISP_INPUT_IMAGE_PATH=/usr/share/visp-images-data/ \
	 && dh_auto_test || ${DH_AUTOTEST_CAN_FAIL}

=== debian/watch ===
version=3
# Mangle upstream pre-releases to make sure they are ordered before
# the final release.
opts=dversionmangle=s/\+dfsg//,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
pgpsigurlmangle=s/$/.asc/ \
http://visp.inria.fr/download \
(?:.*/|)visp-(\d\S*).(?:tar\.(?:gz|bz2|xz)|tgz|tbz2|txz|zip)\b(?<!framework.zip)(?:|\?\S+)
